/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

//DECLARACION DE CLASES
function Jugador (id){ 
	//Propiedades
	
	//Cuerpo
	this.cuerpo_img=new Array();
	this.cuerpo_img[0]=new Image();
	this.cuerpo_img[0].src = URL_IMAGENES+"bodys/{{ appearance.body }}.png";
	this.cuerpo_width=({{ body.width }}/2)*ESCALA_GENERAL;
	this.cuerpo_height=({{ body.height }}/2)*ESCALA_GENERAL;
	this.xref=Math.round(this.cuerpo_width/2);
	this.yref=Math.round(this.cuerpo_height);
	this.escala=1;
	
	//Cara
	this.cara_img=new Image();
	this.cara_img.src=URL_IMAGENES+"faces/{{ appearance.resource.id }}.jpg";
	this.cara_xref={{ appearance.face_x }}*{{ appearance.escala }}; //x respecto al cuerpo
	this.cara_yref={{ appearance.face_y }}*{{ appearance.escala }}; //y respecto al cuerpo
	this.cara_w={{ appearance.face_w }}*{{ appearance.escala }};
	this.cara_h={{ appearance.face_h }}*{{ appearance.escala }};
	
	//Rastro
	this.rastro_img=new Image();
	this.rastro_img.src = URL_IMAGENES+"interface/rastro.png";
	this.xrastro;
	this.yrastro;
	this.rastro_tam=5*ESCALA_GENERAL;
	this.rastro_alpha=0.0;
	
	//Sombra
	this.sombra_img=new Image();
	this.sombra_img.src = URL_IMAGENES+"interface/sombra.png";
	this.sombra_xref=15;
	this.sombra_yref=155;
	this.wsombra=100;
	this.hsombra=30;
	
	//Movimiento
	this.direccion_x=0;
	this.direccion_y=0;
	
	//Metodos
	this.getX=function(){return posX+this.cuerpo_width*this.escala/2;}
	this.getY=function(){return posY+this.cuerpo_height*this.escala;}
	this.getXCara=function(){return posX+this.cara_xref*this.escala;}
	this.getYCara=function(){return posY+this.cara_yref*this.escala;}
	this.getXSombra=function(){return posX+this.sombra_xref*this.escala;}
	this.getYSombra=function(){return posY+this.sombra_yref*this.escala;}
}

function Escenario (id){ 
	//Propiedades 
	this.id=id;
	this.fondo_img=new Image();
	this.fondo_img.src = URL_IMAGENES+"scenarios/tienda_instrumentos.jpg";
	this.fondo_img_blur=new Image();
	this.fondo_img_blur.src = URL_IMAGENES+"scenarios/tienda_instrumentos_blur.jpg";
	this.xini=60*ESCALA_GENERAL;
	this.yini=30*ESCALA_GENERAL;
	
	this.area=new Array(4);
	this.area[0]=new Array(2);
	this.area[1]=new Array(2);
	this.area[2]=new Array(2);
	this.area[3]=new Array(2);
	
	this.area[0][0]=Math.round(67*ESCALA_GENERAL);
	this.area[0][1]=Math.round(60*ESCALA_GENERAL);
	this.area[1][0]=Math.round(75*ESCALA_GENERAL);
	this.area[1][1]=Math.round(47*ESCALA_GENERAL);
	this.area[2][0]=Math.round(100*ESCALA_GENERAL);
	this.area[2][1]=Math.round(65*ESCALA_GENERAL);
	this.area[3][0]=Math.round(130*ESCALA_GENERAL);
	this.area[3][1]=this.area[2][1];
	
	this.objetos=new Array();
}

function Instrumentos(){
	this.area_guitarras=new Array(4);
	this.area_guitarras_x=225;
	this.area_guitarras_y=300;
	this.area_guitarras_w=125;
	this.area_guitarras_h=150;
	this.area_amps=new Array(4);
	this.area_amps_x=325;
	this.area_amps_y=65;
	this.area_amps_w=100;
	this.area_amps_h=100;
	
	this.area_apuntada=-1;
	
	this.destacar_areas=function(x,y){
		this.area_apuntada=-1;
		if(x>=this.area_guitarras_x && x<=this.area_guitarras_x+this.area_guitarras_w && y>=this.area_guitarras_y && y<=this.area_guitarras_y+this.area_guitarras_h)
			this.area_apuntada=TAG_GUITAR;
		else if(x>=this.area_amps_x && x<=this.area_amps_x+this.area_amps_w && y>=this.area_amps_y && y<=this.area_amps_y+this.area_amps_h)
			this.area_apuntada=TAG_AMP;
	}
}

function Ruta (xini,yini,xdes,ydes,area_actual,area_destino){
	//Propiedades 
	this.xcontrol;
	this.ycontrol;
	
	this.n_control=0;
	
	//Establecemos si hay riesgo de esquina
	if(area_actual!=area_destino){
		if(ydes<yini){ //Estoy subiendo
			if(area_destino<area_actual){ //Voy a la izquierda
				var xaux=xini;				
				if(escenario.area[area_destino][1]<escenario.area[area_actual][1]){ //El area es mayor
					while(posicion_relativa(escenario.area[area_destino][0],escenario.area[area_actual][1],xaux,yini,xdes,ydes)){
						xaux++;
					}
				}
					
				this.xcontrol=new Array(2);
				this.xcontrol[0]=xaux;
				this.xcontrol[1]=xdes;
				this.ycontrol=new Array(2);
				this.ycontrol[0]=yini;
				this.ycontrol[1]=ydes;
			}else{ //Voy a la derecha
				if(escenario.area[area_destino][1]<escenario.area[area_actual][1]){ //El area es mayor
					var xaux=xini;
					while(posicion_relativa(escenario.area[area_destino][0],escenario.area[area_actual][1],xaux,yini,xdes,ydes)){
						xaux++;
					}
					
					this.xcontrol=new Array(2);
					this.xcontrol[0]=xaux;
					this.xcontrol[1]=xdes;
					this.ycontrol=new Array(2);
					this.ycontrol[0]=yini;
					this.ycontrol[1]=ydes;
				}
			}
		}else{
			this.xcontrol=new Array(1);
			this.xcontrol[0]=xdes;
			this.ycontrol=new Array(1);
			this.ycontrol[0]=ydes;
		}
	}else{
		this.xcontrol=new Array(1);
		this.xcontrol[0]=xdes;
		this.ycontrol=new Array(1);
		this.ycontrol[0]=ydes;
	}
	
	this.finalizada=function(){
		if(this.n_control<this.xcontrol.length-1){
			this.n_control++;
			if(this.xcontrol[this.n_control]<jugador.getX())
				jugador.direccion_x=1;
			else if(this.xcontrol[this.n_control]>jugador.getX())
				jugador.direccion_x=2;
			if(this.ycontrol[this.n_control]<jugador.getY())
				jugador.direccion_y=1;
			else if(this.ycontrol[this.n_control]>jugador.getY())
				jugador.direccion_y=2;
			return false;
		}else return true;
	}

	this.getX=function(){return this.xcontrol[this.n_control];}
	this.getY=function(){return this.ycontrol[this.n_control];}
}

function Objeto(nombre,x,y,w,h,d){
	//Propiedades
	this.id=nombre;
	this.objeto_img=new Image();
	this.objeto_img.src=URL_IMAGENES+"objects/"+nombre+".png";
	this.x=x*ESCALA_GENERAL;
	this.y=y*ESCALA_GENERAL;
	this.width=w*ESCALA_GENERAL;
	this.height=h*ESCALA_GENERAL;
	this.draggable=d;
	this.dragged=0;
	this.escala=0.5+this.y/ALTURA_EFECTIVA;	
	
	//Sombra
	this.sombra_img=new Image();
	this.sombra_img.src = URL_IMAGENES+"interface/sombra.png";
	this.sombra_xref=15;
	this.sombra_yref=155;
	this.wsombra=100;
	this.hsombra=30;
	
	//Metodos
	this.getXSombra=function(){return this.x+this.sombra_xref*this.escala;}
	this.getYSombra=function(){return this.y+this.sombra_yref*this.escala;}
}

function Bocadillo(nombre,x,y,w,h){
	//Propiedades
	this.id=0;
        this.nombre=nombre;
	this.bocadillo_img=new Image();
	this.bocadillo_img.src=URL_IMAGENES+"interface/bocadillo_"+nombre+".png";
        this.x=x*ESCALA_GENERAL;
        this.y=y*ESCALA_GENERAL;
	this.width=w*ESCALA_GENERAL;
	this.height=h*ESCALA_GENERAL;
	this.bocadillo_alpha=0.0;
        this.estado=0;
        this.texto="";
	
	//Boton de cerrar
	this.cerrar_img=new Array(2);
	this.cerrar_img[0]=new Image();
	this.cerrar_img[0].src=URL_IMAGENES+"interface/cerrar.png";
	this.cerrar_img[1]=new Image();
	this.cerrar_img[1].src=URL_IMAGENES+"interface/cerrar2.png";
	this.cerrar_width=this.width/6;
	this.cerrar_height=this.cerrar_width;
	this.cerrar_x=this.x+this.width-this.cerrar_width;
	this.cerrar_y=this.y+this.cerrar_height;
}

function Dialogo(x,y,w,h,tag){
	
	this.tag=tag;
	if(tag!=-1){
		this.x=x;
		this.y=y;
		this.w=w;
		this.h=h;
		this.alpha=0.0;
		this.opcion_apuntada=-1;
		this.opcion_w=100;
		this.opcion_h=50;
		this.coordenadas_opciones=repartir_elementos(ANCHURA_VENTANA/2,y+h-h/3,2,2,this.opcion_w,this.opcion_h,50);
	}	
}
