from django.http import HttpResponse
from django.shortcuts import render_to_response
import datetime
from django.contrib import auth
from django.http import HttpResponseRedirect
from django.contrib.sessions.models import Session
from django.core.exceptions import ObjectDoesNotExist
import os
from django.conf import settings
from django.db import models
from django.contrib.auth.decorators import login_required
from django.contrib.auth.views import login, logout
from datetime import datetime
# vands_db
from vands.vands_app.models import User, Appearance, UserTempPhoto, Resource, Body
from vands.vands_app.models import UserInstrument, InstrumentModel, InstrumentType
from vands.vands_app.models import UserBand, Band, BandRequest, PracticeLocal, BandTimetable
from vands.vands_app.models import Concert, ConcertRequest
# vands forms
from vands.vands_app.forms import RegisterForm, ResourceForm
# vands methods
from vands.vands_app.models import scaleWithFactor, recortar

###########LOG###########

def redireccion_login(request):
	return HttpResponseRedirect('/login-form')
	
def login_form(request):
	return render_to_response('login_form.html')
	
def login(request):
	username = request.POST['username']
	password = request.POST['password']
	user = auth.authenticate(username=username, password=password)
	if user is not None and user.is_active:
        # Clave correcta, y el usuario esta marcado "activo"
		auth.login(request, user)
		request.session['user'] = user		
		try:
			#Comprobamos si tiene apariencia
			a = Appearance.objects.get(user=request.session['user'])
			# Redirigir a una pagina de exito.
			return HttpResponseRedirect('/room')	
		except ObjectDoesNotExist,e:
			try:
				#Comprobamos si tiene una foto subida
				tr = UserTempPhoto.objects.get(user=request.session['user'])
				return HttpResponseRedirect('/editar_apariencia')
			except ObjectDoesNotExist,e:
				return HttpResponseRedirect('/upload')
	else:
        # Mostrar una pagina de error
		errors=[];
		errors.append('Error en login: Nombre de usuario o Password incorrecto');
		return render_to_response('login_form.html',{'errors':errors})
		
def logout(request):
	if 'user' in request.session:
		auth.logout(request)
	return HttpResponseRedirect('/login-form')
	
def registro(request):
	if request.method == 'POST':
		form = RegisterForm(request.POST)
		if form.is_valid():
			password = request.POST['password']
			password_c = request.POST['password_c']
			errors=[];
			if password == password_c:
				username = request.POST['username']
				try:
					u = User.objects.get(username=username)
					# Mostrar una pagina de error
					errors.append('Error al registrarse: El nombre de usuario ya esta en uso');
					return render_to_response('registro.html',{'form':form,'errors':errors})
				except ObjectDoesNotExist,e:
					email = request.POST['email']
					first_name = request.POST['first_name']
					last_name = request.POST['last_name']
					u = User.objects.create(username=username,first_name=first_name,last_name=last_name,email=email)
					u.set_password(request.POST['password'])
					u.save()
					# Clave correcta, y el usuario esta marcado "activo"
					user = auth.authenticate(username=username, password=password)
					auth.login(request, user)
					request.session['user'] = user		
					return HttpResponseRedirect('/upload')
			else:
				# Mostrar una pagina de error
				errors.append('Error al registrarse: Los passwords que se han escritos son diferentes');
				return render_to_response('registro.html',{'form':form,'errors':errors})
	else:
		form = RegisterForm()
	return render_to_response('registro.html', {'form': form})

###########APARIENCIA###########

@login_required
def upload_file(request):
	if request.method == 'POST':
		form = ResourceForm(request.POST, request.FILES)
		if form.is_valid():
			r = form.save();
			tr = UserTempPhoto.objects.create(user=request.session['user'],resource=r)
			tr.save()
			return HttpResponseRedirect('/editar_apariencia/')
	else:
		form = ResourceForm()
	return render_to_response('upload.html', {'form': form})

@login_required
def editar_apariencia(request):
	return render_to_response('editar_apariencia.html')
		
def editar_apariencia_clases_render(request):
	utp = UserTempPhoto.objects.get(user=request.session['user'])
	bodys = Body.objects.all().order_by('id');
	return render_to_response('src/editar_apariencia/clases.js',{'resource':utp.resource,'bodys':bodys, 'name':request.session['user'].username})

def nueva_apariencia(request,escala,trozo_izquierda,trozo_derecha,trozo_arriba,trozo_abajo,face_x,face_y,body_id,username):
	utp = UserTempPhoto.objects.get(user=request.session['user'])
	r = utp.resource
	#name = os.path.normpath(os.path.join(os.path.dirname(__file__),r.file.name))
	name = os.path.join(os.path.dirname(r.file.path), str(r.id) +'_tmp.'+r.type)
	name_recorte = os.path.join(os.path.dirname(r.file.path), str(r.id) +'.'+r.type)
	size = recortar(name,trozo_izquierda,trozo_derecha,trozo_arriba,trozo_abajo,name_recorte)
	b = Body.objects.get(id=body_id)
	a_nueva = Appearance.objects.create(user=request.session['user'],resource=r,face_x=face_x,face_y=face_y,face_w=size[0],face_h=size[1],escala=escala,body=b,name=username)
	a_nueva.save()
	os.remove(name)
	utp.delete()

	return HttpResponseRedirect('/room')

###########HABITACION###########

@login_required
def room(request):
	return render_to_response('room.html')
	
def room_clases_render(request):
	#Apariencia y cuerpo
	appearance = Appearance.objects.get(user=request.session['user'])
	body = appearance.body;
	#Instrumentos
	try:
		instruments = UserInstrument.objects.get(user=request.session['user'])
		models = instruments.instrument.order_by('type')
	except ObjectDoesNotExist,e:
		models = []
	#Peticiones de banda
	try:
		band_requests = []
		rs = BandRequest.objects.filter(user__exact=request.session['user'])
		for r in rs:
			band_name = r.band.name;
			band_requests.append({
				'request_username': r.request_username,
				'band_name': band_name,
			})		
	except ObjectDoesNotExist,e:
		band_requests = []
	#Peticiones de asistencia a concierto
	try:
		concert_requests = []
		requests = ConcertRequest.objects.filter(user=request.session['user'])
		for request in requests:	
			concert = request.concert;
			concert_requests.append({
				'request_id': request.id,
				'request_username': request.request_username,
				'band_name': concert.band,
			})		
	except ObjectDoesNotExist,e:
		concert_requests = []
	#Conciertos que se han dado
	try:
		userbands = UserBand.objects.get(user=request.session['user'])
		bandas = userbands.bands.order_by('id')
		concerts_done=Concert.objects.filter(band=bandas[0],fecha__lte=datetime.now())
	except ObjectDoesNotExist,e:
		concerts_done = []
	return render_to_response('src/room/clases.js', {'appearance':appearance, 'body':body, 'models':models, 'band_requests':band_requests, 'concert_requests':concert_requests, 'concerts_done':concerts_done})

###########BANDAS###########

@login_required
def bands(request):
	return render_to_response('bands.html')
	
def bands_clases_render(request):
	#Apariencia
	myappearance = Appearance.objects.get(user=request.session['user'])
	try:
		userbands = UserBand.objects.get(user=request.session['user'])
		bandas = userbands.bands.order_by('id')
		datos_bandas=[]
		appearances = []
		datos_miembros=[]
		for banda in bandas:
			datos_banda=[]
			datos_banda.append(banda.id)
			datos_banda.append(banda.name)
			
			miembros=banda.members.order_by('id');
			for miembro in miembros:
				try:
					a=Appearance.objects.get(user=miembro)
					b=a.body
					if a not in appearances:
						datos_miembros.append({
							'id': miembro.id,
							'name': a,
							'escala': a.escala,
							'face_x': a.face_x,
							'face_y': a.face_y,
							'face_w': a.face_w,
							'face_h': a.face_h,
							'resource_id': a.resource.id,
							'body_name': b,
							'body_w': b.width,
							'body_h': b.height,
						})
						appearances.append(a)
				except ObjectDoesNotExist,e:
					a=[]
				datos_banda.append(miembro.id)
			datos_bandas.append(datos_banda);
	except ObjectDoesNotExist,e:
		datos_bandas=[]
		appearances = []
		datos_miembros=[]
	
	return render_to_response('src/bands/clases.js', {'datos_bandas':datos_bandas, 'appearances':appearances,'myappearance':myappearance, 'datos_miembros':datos_miembros})

def nueva_banda(request,name):
	b=Band.objects.create(name=name)
	b.members.add(request.session['user'])
	b.save()
	try:
		ub=UserBand.objects.get(user=request.session['user'])
	except ObjectDoesNotExist,e:
		ub=UserBand.objects.create(user=request.session['user'])
	ub.bands.add(Band.objects.get(name=name))
	ub.save()
	return HttpResponseRedirect('/bands')
	
def borrar_banda(request,banda_id):
	#Comprobamos si la banda a borrar pertenece al usuario y que este es el ultimo miembro
	try:
		ub=UserBand.objects.get(user=request.session['user'])
		b=ub.bands.get(id=banda_id)
		n=b.members.count()
		if n == 1:
			b.delete()
	except ObjectDoesNotExist,e:
		b=[]
	return HttpResponseRedirect('/bands')

def nuevo_miembro(request,name):
	b=Band.objects.get(name=name)
	b.members.add(request.session['user'])
	b.save()
	try:
		ub=UserBand.objects.get(user=request.session['user'])
	except ObjectDoesNotExist,e:
		ub=UserBand.objects.create(user=request.session['user'])
	ub.bands.add(Band.objects.get(name=name))
	ub.save()
	return HttpResponseRedirect('borrar_peticion_banda_'+name+'_1')

def borrar_miembro(request,user_id,band_id):
	u=User.objects.get(id=user_id)
	b=Band.objects.get(id=band_id)
	b.members.remove(u)
	b.save()
	ub=UserBand.objects.get(user=u)
	ub.bands.remove(b)
	ub.save()
	return HttpResponseRedirect('/bands/')

def nueva_peticion_banda(request,username,bandname):
	a = Appearance.objects.get(name=username)
	u = a.user
	b = Band.objects.get(name=bandname)
	ru = request.session['user'].username	
	br=BandRequest.objects.create(user=u,band=b,request_username=ru)
	br.save()	
	return HttpResponseRedirect('/bands/')
	
def borrar_peticion_banda(request,bandname,aceptar):
	b=Band.objects.get(name=bandname)
	br=BandRequest.objects.filter(user=request.session['user'],band=b)
	br.delete()
	if aceptar == '1':
		return HttpResponseRedirect('/bands')
	else:
		return HttpResponseRedirect('/room')

@login_required
def confirmar_miembro(request):	
	return render_to_response('confirmar_miembro.html')
	
def confirmar_miembro_clases_render(request,username,bandname):
	try:
		appearance = Appearance.objects.get(name=username)
		body = appearance.body
		error = 0
	except ObjectDoesNotExist,e:
		appearance = username
		body = []
		error = 1
	return render_to_response('src/confirmar_miembro/clases.js', {'appearance':appearance, 'body':body, 'bandname':bandname, 'error':error})

def confirmar_miembro_javascript_file(request,name):
	path = 'src/confirmar_miembro/'+name+'.js'
	return render_to_response(path)	

###########HORARIO###########

@login_required
def horario(request):	
	return render_to_response('horario.html')
	
def horario_clases_render(request):
	userbands = UserBand.objects.get(user=request.session['user'])
	bandas = userbands.bands.order_by('id')
	bands_timetable=[]
	for banda in bandas:
		band_timetables=BandTimetable.objects.filter(band__exact=banda)
		for bt in band_timetables:
			bands_timetable.append(bt)
	return render_to_response('src/horario/clases.js', {'bands_timetable':bands_timetable,'bandas':bandas})
	
def nuevo_horario(request,bandname,dia,hora_inicio,hora_fin):
	b = Band.objects.get(name=bandname)
	l = PracticeLocal.objects.get(name="Garage")
	bt = BandTimetable.objects.create(band=b,local=l,dia=dia,hora_inicio=hora_inicio,hora_fin=hora_fin)
	bt.save()
	return HttpResponseRedirect('/horario')
	
def borrar_horario(request,bandname,dia,hora_inicio):
	b = Band.objects.get(name=bandname)
	l = PracticeLocal.objects.get(name="Garage")
	bt = BandTimetable.objects.get(band=b,local=l,dia=dia,hora_inicio=hora_inicio)
	bt.delete()
	return HttpResponseRedirect('/horario')

###########TIENDA DE INSTRUMENTOS###########

@login_required
def tienda_instrumentos(request):
	if 'user' in request.session and request.session['user'].is_authenticated():
		return render_to_response('tienda_instrumentos.html')
	else:
		return HttpResponseRedirect('/login-form')
	
def tienda_instrumentos_clases_render(request):	
	appearance = Appearance.objects.get(user=request.session['user'])
	models = InstrumentModel.objects.order_by('type')
	return render_to_response('src/tienda_instrumentos/clases.js', {'appearance':appearance, 'body':appearance.body})

@login_required	
def compra_instrumentos(request):
	return render_to_response('compra_instrumentos.html')
	
def compra_instrumentos_clases_render(request,type):
	models = InstrumentModel.objects.filter(type__exact=InstrumentType.objects.get(name=type))
	return render_to_response('src/compra_instrumentos/clases.js', {'models':models})
	
def compra_instrumentos_javascript_file(request,name):
	path = 'src/compra_instrumentos/'+name+'.js'
	return render_to_response(path)	

def nuevo_instrumento(request,model):
	m = InstrumentModel.objects.get(name=model);
	try:
		ui = UserInstrument.objects.get(user=request.session['user'])
	except ObjectDoesNotExist,e:
		ui = UserInstrument.objects.create(user=request.session['user'])
	ui.instrument.add(m)
	ui.save()
	return HttpResponseRedirect('/tienda_instrumentos')

###########CONCIERTO###########

@login_required
def concert(request):
	return render_to_response('concert.html')
	
def concert_clases_render(request):
	
	try:
		userbands = UserBand.objects.get(user=request.session['user'])
		bandas = userbands.bands.order_by('id')
		conciertos=Concert.objects.filter(band=bandas[0],fecha__lte=datetime.now())
		ordenados=conciertos.order_by('fecha')
		#Obtenemos el concierto de menor fecha
		c=ordenados[0]
		#Obtenemos la banda y sus miembros
		banda=Band.objects.get(name=c.band)
		members=banda.members.order_by('id')
		members_appearances = []
		bodys = []
		instruments = []
		for m in members:
			a=Appearance.objects.get(user=m)
			b=a.body
			ui=UserInstrument.objects.get(user=m)
			models = ui.instrument.order_by('type')
			instruments.append(models[0])
			
			members_appearances.append({
				'id': m.id,
				'name': a,
				'escala': a.escala,
				'face_x': a.face_x,
				'face_y': a.face_y,
				'face_w': a.face_w,
				'face_h': a.face_h,
				'resource_id': a.resource.id,
				'body_name': b,
				'body_w': b.width,
				'body_h': b.height,
			})
			
			
		#Obtenemos el publico asistente
		public=c.public.order_by('id')
		public_appearances = []
		for p in public:
			a=Appearance.objects.get(user=p)
			b=a.body
			public_appearances.append({
				'id': p.id,
				'name': a,
				'escala': a.escala,
				'face_x': a.face_x,
				'face_y': a.face_y,
				'face_w': a.face_w,
				'face_h': a.face_h,
				'resource_id': a.resource.id,
				'body_name': b,
				'body_w': b.width,
				'body_h': b.height,
			})
	except ObjectDoesNotExist,e:
		public_appearances = []
		
	return render_to_response('src/concert/clases.js', {'banda':banda,'members_appearances':members_appearances,'instruments':instruments,'public_appearances':public_appearances})

@login_required
def nuevo_publico(request,cr_id):
	cr = ConcertRequest.objects.get(id=cr_id)
	c = cr.concert
	c.public.add(request.session['user'])
	c.save()
	return HttpResponseRedirect('borrar_peticion_concierto_'+cr_id)

def borrar_peticion_concierto(request,cr_id):
	cr = ConcertRequest.objects.get(id=cr_id)
	cr.delete()
	return HttpResponseRedirect('/room')	

###########LIBRERIAS Y FICHEROS###########
	
def vands_lib(request):
	return render_to_response('lib/vands_lib.js')
	
def CanvasText(request):
	return render_to_response('lib/CanvasText.js')
	
def javascript_file(request,scenario,name):
	path='src/'+scenario+'/'+name+'.js';
	return render_to_response(path)
